//******************************************************************************
//
//   EFEITOS_LED
//
//   AUTOR: CLAUDIO LARIOS         DATA:11-05-2014
//
//   OBJETIVO: GERAR EFEITOS LUMINOSOS USANDO UM PIC 12F675 LIGADO A 12 LEDS
//
//   MONTAGEM APENAS DIDTICA.
//   SUJEITA A BUGS AINDA NO DETECTADO.
//
//******************************************************************************
//#define PERDI_BYTE_CALIBRACAO //descomente apenas se perdeu byte de calibrao
//******************************************************************************

#include <12F675.h>         // includes

#ignore_warnings 203   //desconsidera mensagem de 'condition always true'

#fuses INTRC_IO,NOWDT,NOPROTECT, NOMCLR ,BROWNOUT, PUT  // palavra  configurao
#use delay(clock=4000000)  // clock para 4 mhz
#use fast_io(A)  //  sentido das portas feita pelo programador

#ifdef  PERDI_BYTE_CALIBRACAO  // calibrao do oscilador interno do pic
#ROM  0X3FF = {0X34FC}//mxima freq= 0x34fc ;mdia=0x3480; minima=0x3400
#endif

#byte   tmr0=  0x01
#byte   gpio = 0X05
#byte   tris = 0X85
#bit    modo = 0x05.3
//tabelas
int const v_gpio[]={2,1,32,2,16,32,1,32,2,16,1,16};
int const v_tris[]={60,60,29,29,15,15,30,30,45,45,46,46};
int const max_num_efeito = 5; // maximo numero de efeitos
//VARIAVIS GLOBAIS
int valor,efeito;


//==============================================================================
//               testa boto de 'modo'
//==============================================================================

short testa_modo(){
    valor = READ_ADC();// l valor da tenso de entrada do pino 5
   if(!modo){
      delay_ms(25);
      if(!modo) if(++efeito==max_num_efeito) efeito=0;
      while(!modo);
      delay_ms(25);
      return true;
     }
     else return false;

}


//==============================================================================
//               rotina main
//==============================================================================
Void Main (){
      tris=0b111111; //direo das portas (tudo entrada)
      setup_comparator(NC_NC_NC_NC);// desliga comparadores analgicos
      setup_adc_ports(sAN2 | VSS_VDD);  //seleciona AN2 e 5v como referncia
      setup_adc(ADC_CLOCK_DIV_8 );// ajusta o clock do adc
      set_adc_channel(2); //ajusta para o pino 5 (AN2)
      delay_us(10); //delay
      setup_timer_0 (RTCC_DIV_2);
      efeito=0;
    //  valor=0;
//==============================================================================
//       loop principal

   While (true) {
   int a,b;
   short flag_1=0;

     switch (efeito){
      case 0: // acende pontual do 1 ao 12 reiniciando no 1
         for(a=0;a<12;++a){
            if(testa_modo()) break;
               if(!valor) {valor=1;}// no permite valor=0
               tris=0b111111; //apaga leds para mudana
               gpio=v_gpio[a];// prepara a sada de valores
               tris=v_tris[a];// libera c/ sentido das portas de 'in' p/ 'out'
               delay_ms(valor*20);// tempo que o led ficar aceso
         }
         break;
      case 1: // acende pontual do 12 ao 1 reiniciando no 12
         for(a=0;a<=12;++a){
            if(testa_modo()) break;
            if(!valor) {valor=1;}// no permite valor=0
            tris=0b111111; //apaga leds para mudana
            gpio=v_gpio[12-a];// prepara a sada de valores
            tris=v_tris[12-a];// libera c/ sentido das portas de 'in' p/ 'out'
            delay_ms(valor*20);// tempo que o led ficar aceso
         }
         break;
       case 2: // acende pontual do 12 ao 1 reiniciando no 12
         for(a=0;a<12;++a){
            if(testa_modo()) break;
            if(!valor) {valor=1;}// no permite valor=0
            tris=0b111111; //apaga leds para mudana
            gpio=v_gpio[a];// prepara a sada de valores
            tris=v_tris[a];// libera c/ sentido das portas de 'in' p/ 'out'
            delay_ms(valor*20);// tempo que o led ficar aceso
         }
         for(a=0;a<12;++a){
            if(testa_modo()) break;
            if(!valor) {valor=1;}// no permite valor=0
            tris=0b111111; //apaga leds para mudana
            gpio=v_gpio[12-a];// prepara a sada de valores
            tris=v_tris[12-a];// libera c/ sentido das portas de 'in' p/ 'out'
            delay_ms(valor*20);// tempo que o led ficar aceso
         }

         break;

      case 3: // acende pontual do 12 ao 7/1 ao 6 e volta 7 ao 12/6 ao 1
         b=12;
         flag_1=0;
         for(a=0;a<12;++a){
            if(testa_modo()) break;
            if(!valor) {valor=1;}// no permite valor=0
            tris=0b111111; //apaga leds para mudana
            gpio=v_gpio[b];// prepara a sada de valores
            tris=v_tris[b];// libera c/ sentido das portas de 'in' p/ 'out'
            delay_ms(valor*20);// tempo que o led ficar aceso
         
           
            tris=0b111111; //apaga leds para mudana
            gpio=v_gpio[12-b];// prepara a sada de valores
            tris=v_tris[12-b];// libera c/ sentido das portas de 'in' p/ 'out'
            delay_ms(valor*20);// tempo que o led ficar aceso
            if(!flag_1){
               if(--b<7) {flag_1=1; b=6;}
               
            }
            else {
               if(++b>12){flag_1=0; b=12;}
            }
         }

         break;
      case 4: // acende pontual pseudo-randomicamente
            if(testa_modo()) break;
            tris=0b111111; //apaga leds para mudana
            delay_us(tmr0);
            b=tmr0&0x0f;
            if(b>12) b=0x0f-b;
            gpio=v_gpio[b];// prepara a sada de valores
            tris=v_tris[b];// libera c/ sentido das portas de 'in' p/ 'out'
            delay_ms(valor*20);// tempo que o led ficar aceso
            break;

    }//switch(efeito)
   }//   WHILE (TRUE)
}//VOID MAIN
